<script setup>
</script>

<script>
import jQuery from "jquery";
import Jszip from 'jszip';
import DataTable from 'datatables.net-vue3';
import DataTableLib from 'datatables.net-bs5';
import 'datatables.net-buttons-bs5';
import 'datatables.net-buttons/js/buttons.html5.mjs';
import DataTableResponsive from "datatables.net-bs5";
import axios from 'axios';
import $ from 'jquery';
import swal from 'sweetalert';
import Multiselect from '@vueform/multiselect'
import '@vueform/multiselect/themes/default.css'
// Configurar JSZip
window.JSZip = Jszip;

// Inicializar DataTables con las bibliotecas
DataTable.use(DataTableLib);
DataTable.use(DataTableResponsive);

document.addEventListener("DOMContentLoaded", function () {
  // Obtener la tabla DataTable
  const dataTable = $('#datatable-index-notificaciones').DataTable();

  // Agregar un evento de clic a los elementos con la clase "eliminar" dentro de la tabla

  dataTable.on("click", ".eliminar", function (id) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const id = rowData.id; // Asumiendo que el ID se encuentra en la propiedad 'id'

      swal({
        title: "¿Seguro deseas eliminar?",
        text: "Una vez eliminado no se podra volver a recuperar",
        icon: "warning",
        buttons: true,
        dangerMode: true,
        buttons: ["Cancelar", "Eliminar"],
        confirmButtonClass: "btn-warning",
        cancelButtonClass: "btn-danger"
      })
        .then((willDelete) => {
          if (willDelete) {
            axios.delete(route('notificaciones.destroy',id))
              .then(response => {
                console.log(response);
                swal("Ha sido eliminado exitosamente", {
                  icon: "success",
                  buttons: false
                });
                setTimeout(function () {
                  location.reload();
                }, 1000);
              })
              .catch(error => {
                console.error(error);
                swal("Cancelado", {
                  icon: "error"
                });
              });
          } else {
            console.log('Salvado')
            swal("Cancelado", {
              icon: "error"
            });
          }
        });
    }
  });

  dataTable.on("click", ".eliminar", function (id) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const id = rowData.id; // Asumiendo que el ID se encuentra en la propiedad 'id'

      swal({
        title: "¿Seguro deseas eliminar?",
        text: "Una vez eliminado no se podra volver a recuperar",
        icon: "warning",
        buttons: true,
        dangerMode: true,
        buttons: ["Cancelar", "Eliminar"],
        confirmButtonClass: "btn-warning",
        cancelButtonClass: "btn-danger"
      })
        .then((willDelete) => {
          if (willDelete) {
            axios.delete(route('notificaciones.destroy',id))
              .then(response => {
                console.log(response);
                swal("Ha sido eliminado exitosamente", {
                  icon: "success",
                  buttons: false
                });
                setTimeout(function () {
                  location.reload();
                }, 1000);
              })
              .catch(error => {
                console.error(error);
                swal("Cancelado", {
                  icon: "error"
                });
              });
          } else {
            console.log('Salvado')
            swal("Cancelado", {
              icon: "error"
            });
          }
        });
    }
  });
  

  dataTable.on("click", ".detallesNotificaciones", function (id) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const id = rowData.id;
       window.location.href = route('notificaciones.show',id)
      console.log(id);
    }
  });


});

export default {
  components: { DataTable, Multiselect },
  data() {
    return {
      products: null,

      admin:this.variables?.notificacionesDelete,


    
      columns: [
        { data: null, render: function (data, type, row, meta) { return `${meta.row + 1}` } },
        { data: 'descripcion' },
        { data: 'usuario.nombreCompleto' },
        { data: 'destinatario.nombreCompleto' },
        { data: 'destinatario.nombreInstitucion' },
        { data: 'estadoNotificacion.valor' },
        {
  data: 'createdAt',
  render: function(data, type, row) {
    if (type === 'display' || type === 'filter') {
      const createdAt = new Date(data);
      const formattedDate = createdAt.toLocaleString(); // Otra opción: createdAt.toLocaleDateString() + ' ' + createdAt.toLocaleTimeString();
      return formattedDate;
    }
    return data;
  }
},
{
  data: null,
  render: (data, type, row) => {
    if (this.admin == true) {
      return '<a title="Detalles" href="#a" v-on:click="detalles(id)" class="detallesNotificaciones text-warning"><i class=" mdi mdi-eye font-size-18"></i></a> <a href="#a" class="eliminar text-danger" title="Eliminar"><i class="mdi mdi-delete font-size-20"></i></a>';
    } else {
      return '<a title="Detalles" href="#a" v-on:click="detalles(id)" class="detallesNotificaciones text-warning"><i class=" mdi mdi-eye font-size-18"></i></a>';
    }
  }
}
      ],
      botones: [
        {
          title: 'Lista de notificaciones',
          extend: 'excelHtml5',
          text: '<i class ="far fa-file-excel"></i> Descargar Excel',
          className: 'btn btn-success',
          exportOptions: {
           columns: [1,2, 3, 4,] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
          }
        }
      ]
    }
  },

  mounted() {
    const dataTable = $('#datatable-index-notificaciones').DataTable();
    this.getProducts();
    this.initDataTable();

  },

  props: {
	    variables: Object,
	},

  watch: {
	 
   

 },

  methods: {
    getProducts() {
      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });
  axios.get(route('notificaciones.get.all')).then(
        response => {
          swal.close()
          this.products = response.data.data
        }
      )
    },

    initDataTable() {
    const dataTable = $('#datatable-index-notificaciones').DataTable({

      dom: 'Bfrtip', // Agrega el contenedor de botones
    buttons: [
      {
        extend: 'excelHtml5', // Extensión para exportar a Excel
        title: 'Reporte de bitacora de actividades', // Título del archivo Excel
        text: '<i class ="mdi mdi-file-excel"></i> Descargar Excel',
        className: 'btn btn-success',
        exportOptions: {
        columns: [1,2, 3, 4,5] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
    }
      },
    ],
      destroy: true,
      serverSide: true,
      ajax: {
        url: route('notificaciones.get.all'),
        type: 'GET',
        dataSrc: function (json) {
            json.recordsTotal = json.total;
            json.recordsFiltered = json.total;
            return json.data;
        },
        data: d => {
          d.page = (d.start / d.length) + 1;
        },
      },
      columns: this.columns,

      searching: true,

      
      

      language: {
          processing: "Procesando...",
          search: "Buscar:",
          lengthMenu: "Mostrar _MENU_ registros",
          info: "Mostrando desde _START_ al _END_ de _TOTAL_ registros",
          infoEmpty: "Mostrando ningún elemento.",
          infoFiltered: "(filtrado _MAX_ elementos total)",
          infoPostFix: "",
          loadingRecords: "Cargando registros...",
          zeroRecords: "No se encontraron registros",
          emptyTable: "No hay datos disponibles en la tabla",
          paginate: {
            first: "Primero",
            previous: "Anterior",
            next: "Siguiente",
            last: "Último"
          },
          aria: {
            sortAscending: ": activar para ordenar la columna ascendente",
            sortDescending: ": activar para ordenar la columna descendente"
          }
        },
      
    });
    
    dataTable.on('page.dt', () => {
      swal({
        icon: 'info',
        text: 'Cargando registros...',
        buttons: false,
        closeOnClickOutside: false,
        closeOnEsc: false,
      });
    });

    

    // Añadir un event listener para el evento 'draw'.
    dataTable.on('draw.dt', () => {
      setTimeout(() => {
    swal.close();
  }, 4000);
    });
  },
  
    create: function (event) {
      window.location.href = route('notificaciones.create')

    },


  }
}
</script>

<template>

        <div class="row">
          <div class="col-lg-12">
            <div class="card">
              <div class="card-body">
                <div class=" d-grid gap-2 d-md-flex justify-content-md-end dropdown float-end">
                  <button type="button" v-on:click="create" v-if="can('notificaciones.add')"  id="btn-registrar" class="btn btn-info waves-effect">
                    <i class="bx bx-add-to-queue font-size-16 align-middle me-2"></i> Notificar
                  </button>
                </div>

                <h4 class="card-title mb-4">Lista de notificaciones</h4>
                <div class="table-responsive">
                  <DataTable :data="products" :columns="columns" id="datatable-index-notificaciones" class=" table-condensed table table-bordered dt-responsive  nowrap w-100"
                    :options="{responsive:true,autoWidth:false, dom:'Bfrtip',language:{
                      search: 'Buscar', zeroRecords:'No hay registros para mostrar',
                      info:'Mostrando del _START_ a _END_ de _TOTAL_ registros',
                      infoFiltered: '(Filtrados de _MAX_ registros.)',
                      paginate:{first: 'Primero',previous:'Anterior',next:'Siguiente', last:'Último'}
                    }, buttons:botones}">
                    <thead class="table-light">
                      <tr>
                        <th style="width: 10px;">
                          <div class="form-check font-size-16 align-middle">
                            
                          </div>
                        </th>
                        <th class="align-middle text-center" style="width: 15%;">Descripción</th>
                        <th class="align-middle text-center" style="width: 20%;">Emisor</th>
                        <th class="align-middle text-center" style="width: 20%;">Destinatario</th>
                        <th class="align-middle text-center" style="width: 20%;">Institucion destinatario</th>
                        <th class="align-middle text-center" style="width: 10%;">Estado</th>
                        <th class="align-middle text-center" style="width: 15%;">Fecha emision</th>
                        <th class="align-middle text-center" style="width: 5%;">Acciones</th>
                      </tr>
                    </thead>
                    <tbody style="text-align: center; font-size: 15px;"></tbody>
                  </DataTable>
                </div>
              </div>
            </div>
          </div>
        </div>
    <footer class="footer"></footer>

</template>

<style>
.dataTables_wrapper .dataTables_filter {
  margin-right: 10px;
}

.dataTables_filter{
  display: none;
}

#datatable-index-notificaciones{
  margin-top: 10px;
}



.dt-buttons btn-group {
  background-color: red;
}

@media (min-width: 768px) {
  #TablaPrincipal_wrapper {}
}
</style>
